<template>
	<view>
		<view class="cu-form-group margin-top">
			<view class="title">托盘码</view>
			<input v-model="billNo" placeholder="扫码 / 输入" name="input" @input="findCode()" focus>
			<button v-model="matBtn" class="cu-btn bg-yellow" @click="toggle('right')"><text>+补充</text></button>
			
		</view>
		<!-- <view class="cu-form-group margin-top">
			<view>
				出库口
			</view>
			<view class="uni-list-cell-db">
				<picker @change="bindPickerChange" :value="index" :range="array" range-key="name">
					<view class="uni-input">{{array[index]}}</view>
				</picker>
			</view>
			<view>
				<button v-model="matBtn" class="cu-btn bg-yellow" @click="toggle('right')"><text>+补充</text></button>
			</view>
		</view> -->
		<view class="margin-top">
			<uni-table border stripe emptyText="暂无更多数据">
				<uni-tr>
					<uni-th width="50">数量</uni-th>
					<uni-th width="100">产品ID</uni-th>
					<uni-th width="100">产品名称</uni-th>
					<uni-th width="100">库位</uni-th>
					<uni-th width="100">确认数量</uni-th>
				</uni-tr>
				<uni-tr v-for="(item, index) in locDetlData" :key="index">
					<uni-td>{{item.count}}</uni-td>
					<uni-td>{{item.matNo}}</uni-td>
					<uni-td>{{item.matName}}</uni-td>
					<uni-td>{{item.locNo}}</uni-td>
					<uni-td align="center">
						<button class="uni-button" size="mini" type="primary" @click="conf(index,item)">修改</button>
						<button class="uni-button" size="mini" type="warn" @click="remove(index,item)">删除</button>
					</uni-td>
				</uni-tr>
			</uni-table>
			
		</view>
		<view>
			<button class="cu-btn bg-yellow pda-btn" @click="check">确 认</button>
			<button class="cu-btn bg-grey pda-btn" @click="reset">重 置</button>
		</view>
		<view>
			<uni-popup ref="popup" background-color="#fff" style="width: 500rpx;">
				<view class="popup-content" :class="{ 'popup-height': type === 'left' || type === 'right' }">
						<view class="cu-form-group margin-top">
							<text>补充产品</text>
						</view>
						<view class="cu-form-group margin-top">
							<text class="title">产品ID</text>
							<input type="text" v-model="matNo" placeholder="扫码 / 输入" name="input" autocomplete="off" focus @input="find()">
						</view>
						<view class="cu-form-group margin-top">
							<text class="title">产品名称</text>
							<input type="text" name="input" autocomplete="off" v-model="matName">
						</view>
						<view class="cu-form-group margin-top">
							<text class="title">规格型号</text>
							<input type="text" name="input" autocomplete="off" v-model="specs">
						</view>
						<view class="cu-form-group margin-top">
							<text class="title">单位</text>
							<input type="text" name="input" autocomplete="off" v-model="unit">
						</view>
						<view class="cu-form-group margin-top">
							<text class="title">数量</text>
							<uni-number-box @change="countDom" v-model="count" />
						</view>
						<button class="cu-btn bg-yellow pda-btn2" @click="confirm">补充</button>
						
				</view>
			</uni-popup>
		</view>
		<view>
			<!-- 提示信息弹窗 -->
			<uni-popup ref="message" type="message">
				<uni-popup-message :type="msgType" :message="messageText" :duration="2000"></uni-popup-message>
			</uni-popup>
		</view>
		<view>
			<!-- 输入框示例 -->
			<uni-popup ref="inputDialog" type="dialog">
				<uni-popup-dialog ref="inputClose" mode="input" title="组托数量" 
					placeholder="请输入组托数量" @confirm="dialogInputConfirm">
						<uni-number-box :min="minCount" :max="maxCount" v-model="value" />
				</uni-popup-dialog>
					
			</uni-popup>
		</view>
	</view>
</template>

<script>
	export default {
		data() {
			return {
				msgType: '',
				messageText: '',
				matBtn:'',
				souceData:[], 
				locDetlData:[], // 表格数据
				matNo:'',
				matName:'',
				specs:'',
				unit:'',
				count:'0',
				type: '',
				msgType:'',
				messageText:'',
				baseIP:'',
				outlet:'',
				checkList:[],
				sourceList:[],
				minCount:0,
				maxCount:1,
				billNo:'',
				matData:[],
				rowNum:'',
				value:'',
			}
		},
		mounted(){
			// 获取IP端口
			const UIP = uni.getStorageSync('UIP');
			this.baseIP = UIP
		},
		methods: {
			// 提示窗口
			messageToggle(type) {
				this.msgType = type
				this.messageText = '提取失败'
				this.$refs.message.open()
			},
			// 根据托盘码查询
			findCode() {
				let that = this
				if (that.billNo.length === 0 || that.billNo.length !== 8) {
					return
				}
				let barCode = that.billNo
				// 赋值前清空表格
				that.locDetlData = [] // 初始化表格数据
				uni.request({
					url: that.baseHttp + that.baseIP + that.baseUrl + "/mobile/check/queryMatFromBarCode?barCode=" + barCode,
					header: {
						'content-type':'application/x-www-form-urlencoded',
						'token':uni.getStorageSync('token')
					},
					data: {
						barCode: barCode
					},
					method:'GET',
					success(res) {
						console.log(res)
						if (res.data.code === 200) {
							that.locDetlData = res.data.data
							if (res.data.data && res.data.data.length > 0) {
								res.data.data.map(function(item){
									that.souceData.push(item)
								})
							}
						} else if (res.data.code === 403) {
							uni.navigateBack({
							    delta: 1
							})
						} else {
							that.messageToggle('error')
							that.messageText = res.data.msg
						}
					}
				})
			},
			// 点击补充的弹窗
			toggle(type) {
				this.type = type
				// open 方法传入参数 等同在 uni-popup 组件上绑定 type属性
				this.$refs.popup.open(type)
			},
			messageToggle(type) {
				this.msgType = type
				this.messageText = '提取失败'
				this.$refs.message.open()
			},
			countDom(value) {
				
			},
			// 根据产品ID查询产品详情
			find(){
				let that = this
				let thatId = that.matNo
				if(that.matNo.length===0){
					return;
				}
				uni.request({
					url: that.baseHttp + that.baseIP + that.baseUrl + "/matCode/auth",
					header: {
						'content-type':'application/x-www-form-urlencoded',
						'token':uni.getStorageSync('token')
						},
					data: {
						id:thatId
					},
					method: 'POST',
					success(res){
						let data = res.data.data
							
						if(res.data.code === 200){
							if(data != null){
								that.matName = data.matName
								that.specs = data.specs
								that.unit = data.unit
							}
						} else if (res.data.code ===403 ){
							uni.navigateBack({
							    delta: 1
							})
						} else {
							this.messageToggle('error')
							this.messageText = res.data.msg
						}
					}
				})
			},
			// 弹窗 确认补充
			confirm(){
				let that = this
				let data = {
					matNo:that.matNo,
					matName:that.matName,
					count:that.count
				}
				that.addTableData(data)
				
			},
			// 修改数量
			conf(){
				this.$refs.inputDialog.open()
				this.maxCount = item.count
				this.rowNum = index
				this.value = this.maxCount
			},
			// 修改数量弹窗
			dialogInputConfirm() {
				this.locDetlData[this.rowNum].count = this.value
				this.messageToggle('success')
				this.messageText = '修改成功'	
			},
			// 移除物料
			remove(index,item){
				this.locDetlData.splice(index,1)
				this.messageToggle('success')
				this.messageText = '删除成功'
			},
			// 补充的数据添加到总数据中
			addTableData(data){
				let that = this
				console.log(data.matNo.length)
				if(data.matNo.length === 0){
					that.messageToggle('error')
					that.messageText = '补充失败'
					return
				}
				var toPush = true
				for (var j = 0; j < this.locDetlData.length; j++) {
					if (data.matNo === this.locDetlData[j].matNo && data.locNo === this.locDetlData[j].locNo) {
						toPush = false;
				    }
				}
				if (toPush) {
					var pushData = {
						locNo: this.locDetlData[0] ? this.locDetlData[0].locNo : null,
						matNo: data.matNo,
						count: data.count,
						matName: data.matName
				    }
				    locDetlData.push(pushData);
				}
				this.$refs.popup.close()
				
			},
			// 重置
			reset(){
				this.billNo = ''
				this.addTableData()
			},
			check(){
				if(this.souceData.length === 0) {
					this.messageToggle('error')
					this.messageText = '站点无货，无法盘点'
					return
				}
				if(this.locDetlData.length > 0) {
					for(var i = 0; i < that.locDetlData.length; i++){
						if (that.locDetlData[i].count === null || that.locDetlData[i].count === 0 || 
						that.locDetlData[i].count === undefined) {
							this.messageToggle('error')
							this.messageText = that.locDetlData[i].matNo + '商品数量错误'
							return
						}
					}
				}
				if (this.locDetlData.length > 0) {
				    this.locDetlData.map(function (item) {
				        this.checkList.push({
				            locNo: item.locNo,
				            matNo: item.matNo,
				            checkQty: item.count
				        });
				    });
				}
				if (this.souceData.length > 0) {
				    this.souceData.map(function (item) {
				        this.sourceList.push({
				            locNo: item.locNo,
				            matNo: item.matNo,
				            count: item.count
				        });
				    });
				}
				uni.request({
					url: that.baseHttp + that.baseIP + that.baseUrl + "/mobile/stock/check",
					header: {
						'token':uni.getStorageSync('token')
					},
					data: JSON.stringify({
						checkList: this.checkList
					}),
					method:'POST',
					async:false,
					success(res){
						if(res.data.code === 200){
							this.reset();
							this.messageToggle('success')
							this.messageText = '盘点成功'
						} else if (res.data.code === 403) {
							uni.navigateBack({
							    delta: 1
							})
						} else {
							this.messageToggle('error')
							this.messageText = res.data.msg
						}
						
					} 
				})
			}
		}
	}
</script>

<style>
	
</style>
